library ieee;
use ieee.std_logic_1164.all;

entity conta4 is
  port ( clk, rst: in std_logic;
         conto: out std_logic_vector(1 downto 0)
         );
end conta4;


architecture beh of conta4 is
  signal nconto, rconto : std_logic_vector(1 downto 0);

  begin
    
    -- registro
     rconto <= "00" after 1 ns when rst='1' else
              nconto after 1 ns when clk='0' and clk'event;
              
     -- rete combinatoria stato prossimo         
     with rconto select 
         nconto <= "01" when "00",
                   "10" when "01",
                   "11" when "10",
                   "00" when others;
                   
     conto <=rconto;
end beh;                 
              