library ieee;
use ieee.std_logic_1164.all;

entity mux2x1 is
  generic ( d: integer range 0 to 31);
  port (a, b : in std_logic_vector(d downto 0);
        s: in std_logic;
        q: out std_logic_vector(d downto 0)
        );
end mux2x1;

architecture beh of mux2x1 is
 begin
    q <= a after 1 ns when s = '0' else
         b after 1 ns;
end beh;