library ieee;

use ieee.std_logic_1164.all;


entity mux4x1 is
  port (a,b,c,d: in std_logic_vector(7 downto 0);
        s1, s0 : in std_logic;
        q: out std_logic_vector(7 downto 0)
        );
      end mux4x1;
      
architecture schematic of mux4x1 is
 component mux2x1 is
  generic ( d: integer range 0 to 31);
  port (a, b : in std_logic_vector(d downto 0);
        s: in std_logic;
        q: out std_logic_vector(d downto 0)
        );
end component;

signal q0,q1: std_logic_vector(7 downto 0);

begin
  m0: mux2x1 generic map (8)
             port map(a,b, s0,q0);
  m1: mux2x1 generic map (8)
              port map(c,d, s0, q1);
  m2: mux2x1 generic map (8) 
              port map (q0, q1, s1, q);
end schematic;