libray ieee;
use ieee.std_logic_1164.all;

entity mux2x1 is
port (a,b, s: in std_logic;
      q:  out std_logic ); 
end mux2x1;

architecture schematic of mux2x1 is
 component and2 is
   port(a,b: in std_logic;
         q: out std_logic);
 end component;
 
 component or2 is
    port(a,b: in std_logic;
         q: out std_logic);
end component;

signal a1,a2,ns: std_logic;

 begin
  ns <=not s;
  
  u1: and2 port map (a, ns, a1);
  u2: and2 port map (b, s, a2);
  u3: or2 port map(a1, a2, q);
  
end  beh;

  